clear
load('moredata')
savename = {'comparchdata25.txt'}
w = getwfm25;
h = 4;              % threshold for high and low values
thresh =  7e-5;     % threshold between two frequencies

figure(7)
clf
plot(w(:,1),w(:,2))
hold all

count = 1;
codecount = 0;
dcount = 1;
last = -1;
testcount= 1;
timeit = 0;
for i = 2:length(w(:,2))
    w(i,2) = (w(i,2) > h) ; % converting w to highs and lows
    
    if (w(i,2) ~= w(i-1,2)) && ( w(i,2) == 1) 
         if count > 1
            lman(count-1) = (w(i,1) - l)> thresh;
            testit(testcount,:) = [0,0];
            testcount = testcount + 1;
            timeit = timeit + 1 + 1 * ((w(i,1) - l)> thresh);
            testit(testcount,:) = [1,timeit];
            testcount = testcount + 1;
            
         end
        if count > 4
            % Correcting for slight errors
            if (lman(count-3) ~= lman(count-4)) &&(lman(count-3) ~= lman(count-2))
                if  lman(count-2) ~=  lman(count-1)
                    lman(count-2) =  lman(count-1);
                end
                lman(count-3) = lman(count-2);
            end
            
            % Begin extracting the actual manchester encoding
            if count == 5
                mcount = 1;
                manchester(mcount) = lman(count- 2);
                changetime(mcount) = count
                same = -1;
            end
            
            % Dont add another manchester bit
            if (manchester(mcount) == lman(count -2)) && (same < 6)
                same = same + 1;
            else                
                % Add another manchester bit
                % if the manchester bit is the same as the last manchester
                % bit the change the value of the code bit
                if lman(count - 2) == manchester(mcount)
                    last = last * -1;                    
                end
                
                % if the manchester bit is high add the next code bit
                if lman(count -2) == 1
                    code(dcount) = last > 0;
                    dcount = dcount + 1;
                end
                % Add the new manchester bit
                mcount = mcount + 1;
                manchester(mcount) = lman(count - 2);
                changetime(mcount) = count;
                same = 0;
            end
            
        end
        l = w(i,1);
        count = count + 1;
    end
end

figure(10)
clf
bar(lman)
hold all
plot(changetime, manchester,'ro','markerfacecolor','r');
dlmwrite(savename{1},code*1, '') % write decoded data to file
dlmwrite('testdata.txt',testit(:,1), ' ') % write decoded data to file
dlmwrite('testtime.txt',testit(:,2), ' ') % write decoded data to file